package pinball.menuevent;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;

import java.awt.event.*;
import java.awt.*;

/**
 * Event for when the display is in verbose mode.
 */
public class PinballVerbose implements ActionListener {
	
	/** Verbose button, used to change color. */
	private Button verbose;
	
	/** 
	 * Get the verbose button.
	 *
	 * @param verbose verbose button. 
	 */
	public PinballVerbose(Button verbose) {
		this.verbose=verbose; 
	}
	
    	/**
    	 * Verbose button is pressed. 
    	 */
    	public void actionPerformed(ActionEvent e) {
    			/* Turn off verbose mode. */
			if(GameOptions.verbose()) {
				verbose.setBackground(Color.lightGray);
				GameOptions.verbose(false);
				verbose.setLabel("Difference");
			}
			
			/* Turn on verbose mode. */
			else if(!GameOptions.verbose()) {
				verbose.setBackground(Color.red);
				GameOptions.verbose(true);
				verbose.setLabel("Normal");
			}
    	}
}
