package pinball.player;


/**
 * Used to define the location of an object. Used by flippers at the moment.
 */
public class Location {
	/** Location of object. */
	private int x,y;
	
	/**
	 * Make a new location.	 
	 *
	 * @parm x x location.
	 * @parm y y location.
	 */	 
	public Location(int x, int y) {
		this.x=x;
		this.y=y;
	}
	
	/**
	 * Make a new location.	Default is -1,-1.
	 *
	 */	 
	public Location() {
		this.x=-1;
		this.y=-1;
	}
	
	/**
	 * X location. 
	 *
	 * @param x set x location.
	 */
	public void x(int x) {
		this.x=x;
	}
	
	/**
	 * Y location. 
	 *
	 * @param y set y location.
	 */
	public void y(int y) {
		this.y=y;
	}
	
	/**
	 * Get the x location of the object.
	 *
	 * @return x location. 
	 */ 
	public int x() {
		return x;
	}

	/**
	 * Get the y location of the object.
	 *
	 * @return y location. 
	 */ 
	public int y() {
		return y;
	}
}
