package pinball.player.tripwire;

import pinball.*;
import pinball.buffer.*; 
import pinball.part.*;
import pinball.server.*;
import pinball.player.*;


import java.util.*;
import java.io.*;
import java.awt.*;


/** 
 * The strategy thread for the player who sees only a line near the flippers. 
 */
public class TripwireStrategy extends Strategy {
	/* Old dimentions of the frame. */
	
	/** Old width. */
	private int oldWidth;

	/** Old Height. */
	private int oldHeight; 
	
	/** Old Xoffset. */
	private int oldXOffset; 
	
	/** Old Yoffset. */	
	private int oldYOffset; 
	
	/** Old flipperZone. */
	private int oldFlipperZone;
		
	/** Did it go to full screen. */
	private boolean resizedFull=true;
	
	/** Did it go to small screen. */
	private boolean resizedSmall=false;
			
	
	/** 
	 * The strategy thread for the player. 
	 *
 	 * @param buffer the first buffer in the series of buffers for the system.
	 * @param gameStats the area to write the game stats to.
 	 * @param camera the camera for the system.
	 */	
	public TripwireStrategy(Buffer buffer,TextArea gameStats, Camera camera) {
		id="twire";
		this.stub=new Stub(buffer,gameStats,this,camera);
		stub.setPriority(Thread.NORM_PRIORITY);
		
		boarder=4;
		GameOptions.ballMax(6);
		GameOptions.pixelThreshold(10);
		GameOptions.moveThreshold(5);
		stub.boarder(boarder);
		System.err.println("Strategy: "+id);	
	}

	/* For extendted class. */
	public TripwireStrategy(){}
	
	/**
	 * Resize to only see a line above the flippers. 
	 */
	public void option() {
		if(firstTime) {		
		
			/* Save the original size of the image. */
			oldWidth=buffinfo.width();
			oldHeight=buffinfo.height();
			oldXOffset=buffinfo.XOffset();
			oldYOffset=buffinfo.YOffset();
 			oldFlipperZone=stub.flipperZone();	
			flipperHeight=0;
					
			stub.headerInfo(stub.number()+" flipperHeight="+flipperHeight);
			//outZone=buffinfo.YOffset()+ysize-fromBottom;
			stub.headerInfo(stub.number()+" outZone="+outZone);
			stub.headerInfo(stub.number()+" top="+fromTop);
				stub.headerInfo(stub.number()+" flipperDistance="+boarder);
			top=oldYOffset+fromTop;
			stub.topBottom(top,outZone);
			
			/* Never let the ball go out of play. */
			stub.outZone(buffinfo.height()+1);
			
//			System.err.println("OUTZONE "+outZone);
			firstTime=false;
			
			GameOptions.moveThreshold(buffinfo.width());						
		}	
			 
		/* Make small. */					
		if(stub.statsBallInPlay() && !resizedFull) {
			/* Make new image size. */

			/* Height of the image. */
			int size=10;
			int upFromFlippers=5;			
			
			/* Average height of the flippers. */
			int flippers=(stub.leftY()+stub.rightY())/2;

			stub.resize(buffinfo.width(),size,0,flippers-upFromFlippers);
 			
			resizedFull=true;
			resizedSmall=false;
			
			System.err.println("*********************Make Small");
			System.err.println("Resize requested by frame: "+buffinfo.number());

		}
		
		/* Make original. */
		else if(!stub.statsBallInPlay() && !resizedSmall) {
			stub.resize(oldWidth,oldHeight,oldXOffset,oldYOffset);
			top=fromTop;
			
//			System.err.print("RESIZE "+oldWidth+" "+oldHeight);
			
			resizedSmall=true;
			resizedFull=false;
			System.err.println("*********************Make BIG");
			System.err.println("Resize requested by frame: "+buffinfo.number());
		}							
	}
	
	/**
	 * Check if the flippers need to be reset and then decide if they need to be flipped.
	 */
	public void flippersCheck() {
		
		/* See if it's time to reset the flippers. */	
		flippersReset();

		/* Descide to weither to flip. */
		if(stub.statsBallInPlay())
			decision();

	} 
	
	
}
